//+------------------------------------------------------------------+
//|                                                ZigZag600 v1c.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double lots      = 0.1;
extern int    Step      = 10;
extern int    deltaPeak = 15;
extern int    MM        = 1;
extern int    StepOrder = 10;

extern int    Magic     = 1112;
extern int    Max       = 30;
extern int    deviation = 0;
extern int    Spread    = 0;

double zz, mm, price, avrprice, profit, ll;
int    nn, pos, order;
int    sp;
int    ticket[50];


bool   AllMessages = true;
bool   PrintEnable = true;
bool   gbDisabled  = False;           //   
bool   MarketWatch = True;            //    "Market Watch".
int    Slippage    = 3;               //  
int    NumberOfTry = 5;               //   
int    modeSetOrders = 2;              //   :

#include <stdlib.mqh>             //  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   if(Spread == 0) {
      sp = MarketInfo(Symbol(), MODE_SPREAD);
   } else {
      sp = Spread;
   }
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int i, tt = 0;
   bool fl = false;
   RefreshOrder();
   if((pos == 0)&&(Volume[0] < 20)) {
      for(i = 1; i < 5; i++) {
         mm = iMA(Symbol(), PERIOD_M1, 600, 0, MODE_LWMA, PRICE_CLOSE, i);
         zz = iCustom(Symbol(), 0, "ZigZag", 600, 5, 3, 0, i);
         if(zz > 0) {
            if((zz > mm)&&(Bid - mm > 10 * Point)) {
               fl = true;
               nn = -1;
            }
            if((zz < mm)&&(mm - Ask  > 10 * Point)&&(zz > 0)) {
               fl = true;
               nn = 1;
            }
            break;
         }
      }
      mm = iMA(Symbol(), PERIOD_M1, 600, 0, MODE_LWMA, PRICE_CLOSE, 1);
   }
   if(pos > 0) {
      Comment(" ", TimeToStr(TimeCurrent(), TIME_MINUTES), ".  = ", DoubleToStr(profit, 2), ".   = ", DoubleToStr(avrprice, Digits), ".   = ", DoubleToStr(ll, 2));
   } else {
      if(fl) {
         Comment(" ", TimeToStr(TimeCurrent(), TIME_MINUTES), ",  = ", i, ", ZigZag = ", zz);
      } else {
         Comment(" ", TimeToStr(TimeCurrent(), TIME_MINUTES), ".   .");
      }
   }

   if((pos == 0)&&(order == 0)) {
      if(fl) {
         if(nn == 1) {
            price = NormalizeDouble(zz + deltaPeak * Point, Digits);
            for(i = 0; i < 200; i++) {
               if(mm - price < Step * Point) {
                  break;
               }
               SetOrder(Symbol(), OP_BUYSTOP, GetLot(), price, 0, 0, Magic, DoubleToStr(price, Digits), 0);
               price = NormalizeDouble(price + Step * Point, Digits);
            }
         }
         if(nn == -1) {
            price = NormalizeDouble(zz - deltaPeak * Point, Digits);
            for(i = 0; i < 200; i++) {
               if(price - mm < Step * Point) {
                  break;
               }
               SetOrder(Symbol(), OP_SELLSTOP, GetLot(), price, 0, 0, Magic, DoubleToStr(price, Digits), 0);
               price = NormalizeDouble(price - Step * Point, Digits);
            }
         }
      }
   }
      if(nn == 1) {
         mm = NormalizeDouble(iMA(Symbol(), PERIOD_M1, 600, 0, MODE_LWMA, PRICE_CLOSE, 1), Digits);
         if((avrprice > mm)||(Bid > mm)) {
            mm = NormalizeDouble(iMA(Symbol(), PERIOD_M5, 600, 0, MODE_LWMA, PRICE_CLOSE, 1), Digits);
         }
         if((avrprice > mm)||(Bid > mm)) {
            mm = NormalizeDouble(iMA(Symbol(), PERIOD_M15, 600, 0, MODE_LWMA, PRICE_CLOSE, 1), Digits);
         }
         if(avrprice > mm) {
            mm = NormalizeDouble(avrprice + Step * Point, Digits);
         }
      }
      if(nn == -1) {
         mm = NormalizeDouble(iMA(Symbol(), PERIOD_M1, 600, 0, MODE_LWMA, PRICE_CLOSE, 1) + sp * Point, Digits);
         if((avrprice < mm)||(Ask < mm)) {
            mm = NormalizeDouble(iMA(Symbol(), PERIOD_M5, 600, 0, MODE_LWMA, PRICE_CLOSE, 1) + sp * Point, Digits);
         }
         if((avrprice < mm)||(Ask < mm)) {
            mm = NormalizeDouble(iMA(Symbol(), PERIOD_M15, 600, 0, MODE_LWMA, PRICE_CLOSE, 1) + sp * Point, Digits);
         }
         if(avrprice < mm) {
            mm = NormalizeDouble(avrprice - Step * Point, Digits);
         }
      }
   if((order > 0)||(pos > 0)) {
      if(Ask < mm) {
         DeleteOrders(Symbol(), OP_SELLSTOP, Magic);
         price = NormalizeDouble(price - Step * Point, Digits);
         while(price > Ask + deltaPeak * Point) {
            fl = true;
            for(i = 0; i < OrdersTotal(); i++) {
               if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
                  if((OrderSymbol() == Symbol())&&(OrderMagicNumber() == Magic)&&(OrderType() == OP_BUYSTOP)) {
                     if(NormalizeDouble(StrToDouble(StringTrimLeft(OrderComment())), Digits) == price) {
                        fl = false;
                        break;
                     }
                  }
               }
            }
            if(fl) {
               SetOrder(Symbol(), OP_BUYSTOP, GetLot(), price, 0, 0, Magic, DoubleToStr(price, Digits), 0);
            }
            price = NormalizeDouble(price - Step * Point, Digits);
         }
      }
      if(Bid > mm) {
         DeleteOrders(Symbol(), OP_BUYSTOP, Magic);
         price = NormalizeDouble(price + Step * Point, Digits);
         while(price < Bid - deltaPeak * Point) {
            fl = true;
            for(i = 0; i < OrdersTotal(); i++) {
               if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
                  if((OrderSymbol() == Symbol())&&(OrderMagicNumber() == Magic)&&(OrderType() == OP_SELLSTOP)) {
                     if(NormalizeDouble(StrToDouble(StringTrimLeft(OrderComment())), Digits) == price) {
                        fl = false;
                        break;
                     }
                  }
               }
            }
            if(fl) {
               SetOrder(Symbol(), OP_SELLSTOP, GetLot(), price, 0, 0, Magic, DoubleToStr(price, Digits), 0);
            }
            price = NormalizeDouble(price + Step * Point, Digits);
         }
      }
   }
   if(pos > 0) {
      for(i = 0; i < OrdersTotal(); i++) {
         if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if((OrderSymbol() == Symbol())&&(OrderMagicNumber() == Magic)&&((OrderType() == OP_BUY)||(OrderType() == OP_SELL))) {
               if(MathAbs(OrderTakeProfit() - mm) > NormalizeDouble(deviation * Point, Digits)) {
                  ModifyOrder(-1, 0, mm, 0);
               }
            }
         }
      }
   }
   for(i = 0; i < OrdersTotal(); i++) {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if((OrderSymbol() == Symbol())&&(OrderMagicNumber() == Magic)) {
            if (OrderType() == OP_BUYSTOP) {
               if(mm - OrderOpenPrice() < Point) {
                  OrderDelete(OrderTicket());
               }
            }
            if(OrderType() == OP_SELLSTOP) {
               if(OrderOpenPrice() - mm < Point) {
                  OrderDelete(OrderTicket());
               }
            }
         }
      }
   }
   return(0);
}

void RefreshOrder() {
   ll = 0;
   pos = 0;
   order = 0;
   avrprice = 0;
   profit   = 0;
   price   = -1;
   for(int kk = 0; kk < 50;kk++) {
      ticket[kk] = 0;
   }
   kk = 0;
   for(int i = 0; i < OrdersTotal(); i++) {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if((OrderSymbol() == Symbol())&&(OrderMagicNumber() == Magic)) {
            if(OrderType() == OP_BUY) {
               pos++;
               profit += OrderProfit();
               ll += OrderLots();
               avrprice += OrderOpenPrice() * OrderLots();
               if(price < 0) {
                  price = StrToDouble(StringTrimLeft(OrderComment()));
               } else {
                  if(price > OrderOpenPrice()) {
                     price = OrderOpenPrice();
                  }
               }
               nn = 1;
            }
            if(OrderType() == OP_SELL) {
               pos++;
               profit += OrderProfit();
               ll += OrderLots();
               avrprice += OrderOpenPrice() * OrderLots();
               if(price < 0) {
                  price = StrToDouble(StringTrimLeft(OrderComment()));
               } else {
                  if(price < OrderOpenPrice()) {
                     price = OrderOpenPrice();
                  }
               }
               nn = -1;
            }
            if(OrderType() == OP_BUYSTOP) {
               order++;
               if(price < 0) {
                  price = StrToDouble(StringTrimLeft(OrderComment()));
               } else {
                  if(price > OrderOpenPrice()) {
                     price = OrderOpenPrice();
                  }
               }
            }
            if(OrderType() == OP_SELLSTOP) {
               order++;
               if(price < 0) {
                  price = StrToDouble(StringTrimLeft(OrderComment()));
               } else {
                  if(price < OrderOpenPrice()) {
                     price = OrderOpenPrice();
                  }
               }
            }
         }
      }
   }
   if(avrprice > 0) {
      avrprice = NormalizeDouble(avrprice / ll, Digits);
   }
}

double GetLot() {
   double ret = lots;
   int    i, kk;
   if(MM == 1) {
      ret = NormalizeDouble(ret * (MathFloor((pos + order) / StepOrder) + 1), 2);
   }
   if(MM == 2) {
      kk = MathFloor((pos + order) / StepOrder);
      if(kk > 0) {
         for(i = 0; i < kk; i++){
            ret = NormalizeDouble(ret * 2, 2);
         }
      }
   }
   if(MM == 3) {
      if(pos + order > StepOrder - 1) {
         ret = NormalizeDouble(lots * 2, 2);
      }
   }
   if(MM == 4) {
      kk = pos + order;
      for(i = 2; i <= kk; i++) {
         ret = NormalizeDouble(ret * 2, 2);
      }
   }
   return(ret);
}


//+------------------------------------------------------------------+


//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :                                                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int  err, i, it, k=OrdersTotal(), ot;

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            for (it=1; it<=NumberOfTry; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket(), CLR_NONE);
              if (fd) {
                break;
              } else {
                err=GetLastError();
                Print("Error(",err,") delete order ",GetNameOP(ot),": ",ErrorDescription(err),", try ",it);
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("Unknown Period");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 10.04.2008                                                     |
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//|    co -                                                         |
//+----------------------------------------------------------------------------+
int OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") {
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;

  if (sy=="" || sy=="0") sy=Symbol();
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, CLR_NONE);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, CLR_NONE);
    if (ticket>0) {
      break;
    } else {
      err=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
  return(ticket);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, CLR_NONE);
      if (fm) {
        break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  static string prevMessage="";
  Comment(m);
  if (StringLen(m)>0 && PrintEnable) {
    if (AllMessages || prevMessage!=m) {
      prevMessage=m;
      Print(m);
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 02.08.2008                                                     |
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    co -                                                         |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, string co="", datetime ex=0) {
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, ex, CLR_NONE);
    if (ticket>0) {
      break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
          break;
        }
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        continue;
      }
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Message("SetOrder():       "+sy);
      Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      //  
      if (err==130) {
        //   
        if (modeSetOrders==1) {
          Sleep(1000*5.3);
          switch (op) {
            case OP_BUYLIMIT:
              if (pp>pa-msl*mp) pp=pa-msl*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_BUYSTOP:
              if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_SELLLIMIT:
              if (pp<pb+msl*mp) pp=pb+msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
            case OP_SELLSTOP:
              if (pp>pb-msl*mp) pp=pb-msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
          }
          Print("SetOrder():   ");
          continue;
        }
        //    
        if (modeSetOrders==2) {
          Print("SetOrder():    ");
          if (op==OP_BUYLIMIT || op==OP_BUYSTOP) OpenPosition(sy, OP_BUY, ll, sl, tp, mn, co);
          if (op==OP_SELLLIMIT || op==OP_SELLSTOP) OpenPosition(sy, OP_SELL, ll, sl, tp, mn, co);
          break;
        }
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}

